-- (C) Copyright International Business Machines Corporation 16 September
-- 1991.  All Rights Reserved.
--
-- See the file USERAGREEMENT distributed with this software for full
-- terms and conditions of use.
-- SCCS Info: @(#)chphase3.d	1.1 9/25/91

chphase3: using(chdescriptors, chinternal, chtransform, interpform)

  definitions
    
    upstate : callmessage(
	statements : ch_statements,
	references : referencesFn
      )
    constant(references)
    exit {full};
    upstateQ : inport of upstate {full};
    upstateFn : outport of upstateQ;
    
    replaces : table of replace {full} KEYS(old);
    replace : record(
	old : integer,
	new : integer
      );
    
    encode : callmessage(
	ch : chcontrols,
	cblocks : cblocks,
	statements : ch_statements,
	operands : ch_operands,
	string : charstring,
	pool : pooled_qualifiers
      )
    constant (cblocks, statements, operands)
    exit {full};
    encodeQ : inport of encode {full};
    encodeFn : outport of encodeQ;
    
    unify_cblocks : callmessage(
	statements : ch_statements,
	cblocks : cblocks
      )
    exit {full};
    unify_cblocksQ : inport of unify_cblocks {full};
    unify_cblocksFn : outport of unify_cblocksQ;
        
  end definitions

